package bbdd;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteDatabase.CursorFactory;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

public class PillControlDbHelper extends SQLiteOpenHelper {

private static int version = 4;
private static String name = "PillControl20" ;
private static CursorFactory factory = null;

public PillControlDbHelper(Context context)
{	
	
    super(context, name, factory, version);
    
}

@Override
public void onCreate(SQLiteDatabase db)
{
    Log.i(this.getClass().toString(), "Creando base de datos");

    db.execSQL( "CREATE TABLE MEDICINA(" +
                " _id INTEGER PRIMARY KEY," +
                " hip_nombre TEXT, " +
                " hip_descripcion TEXT, " +
                " hip_cantidad TEXT," +
                " hip_tomarCada TEXT," +
                " hip_efectosSecundarios TEXT," +
                " hip_observaciones TEXT," + 
				" hip_duracion INTEGER," +
				" hip_horaInicio INTEGER," +
				" hip_cronico TEXT," +
				" hip_ultimaGeneracion TEXT," +
				" hip_ultimaHora TEXT," +
    			" hip_fechaInicio TEXT)");
                

    db.execSQL( "CREATE UNIQUE INDEX hip_nombre ON MEDICINA(hip_nombre ASC)" );
    db.execSQL( "CREATE TABLE IMAGENES(" +
            " _id INTEGER PRIMARY KEY," +
            " hip_foto BLOB)");
    
    //db.execSQL("DROP TABLE TOMA");

   db.execSQL( "CREATE TABLE TOMA(" +
                " _id INTEGER PRIMARY KEY," +
                " hip_cantidad STRING, " +
                " hip_hora TEXT, " +
                " hip_fecha DATE, " +
                " hip_flarga DATETIME, " +
                " hip_tomada TEXT," +          
                " hip_medicina INTEGER," +
                " hip_nombreMedicina TEXT," +
                " hip_notificada TEXT," +
                " hip_fechatomada DATETIME," +
                " hip_foto TEXT," +
                " FOREIGN KEY (hip_medicina) REFERENCES Medicina (_id) ON DELETE CASCADE)");
    
    Log.i(this.getClass().toString(), "Tabla MEDICINA creada");
   
    /*
     * Insertamos datos iniciales
     */
   db.execSQL("DELETE FROM MEDICINA");
   db.execSQL("DELETE FROM TOMA");
  

  db.execSQL( "CREATE TABLE PERFIL(" +
                " _id INTEGER PRIMARY KEY," +
                " hip_nombre TEXT NOT NULL, " +
                " hip_fNacimiento TEXT, " +
                " hip_edad TEXT," +
                " hip_usuario TEXT," +
                " hip_passwd TEXT);" );

  //  db.execSQL( "CREATE UNIQUE INDEX hip_nombre ON PERFIL(hip_nombre ASC);" );

    Log.i(this.getClass().toString(), "Tabla PERFIL creada");
 
    /*
     * Insertamos datos iniciales
     */
   db.execSQL("DELETE FROM PERFIL");
 
   
   
    db.execSQL("INSERT INTO PERFIL(_id, hip_nombre, hip_fNacimiento, hip_edad, hip_usuario, hip_passwd ) VALUES(1,'defalult','01/01/1980', ' ', ' 112 ',' ')");
    

}


public void update (SQLiteDatabase db){
	

}
public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion)
{
    // Actualización a versión 2
    if (oldVersion < 2)
    {
        upgrade_2(db);
    }
    // Actualización a versión 3
    if (oldVersion < 3)
    {
        upgrade_3(db);
    }
    // Actualización a versión 4
    
}

    private void upgrade_2(SQLiteDatabase db)
    {
        
    }

    private void upgrade_3(SQLiteDatabase db)
    {
        //
        // Upgrade versión 3: Incluir pasivo_sn
        //
        db.execSQL("ALTER TABLE MEDICINA ADD hip_pasivo_sn   VARCHAR2(1) NOT NULL DEFAULT 'N'");

        Log.i(this.getClass().toString(), "Actualización versión 3 finalizada");
    }
}
    
