package controlador;



import java.util.ArrayList;
import java.util.Calendar;

import com.pillcontrol.medicinas.R;
import com.pillcontrol.medicinas.R.drawable;
import com.pillcontrol.medicinas.R.id;
import com.pillcontrol.medicinas.R.layout;
import com.pillcontrol.medicinas.R.menu;
import com.pillcontrol.medicinas.R.string;

import servicio.Servicio;

import modelo.Medicina;
import modelo.MedicinaAdaptador;
import modelo.MedicinaDbAdapter;
import modelo.PerfilDbAdapter;
import modelo.Toma;
import modelo.TomaAdapter;
import modelo.TomaDbAdapter;


import android.support.v7.app.ActionBarActivity;
import android.app.AlarmManager;
import android.app.AlertDialog;
import android.app.ListActivity;
import android.app.PendingIntent;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class Configurar extends ListActivity {
	
    private ListView lista;
    private static PendingIntent pendingIntent=null;
    public static final String C_MODO  = "modo" ;
    public static final int C_VISUALIZAR = 551 ;
    public static final int C_CREAR = 552 ;
    public static final int C_EDITAR = 553 ;
    public static final int C_ELIMINAR = 554 ;
    public static final int C_CONFIGURAR = 555 ;
    public static final int C_NOTIFICAR = 556 ;
    public static final int C_CAMARA = 557 ;	
    public boolean bandera=false; 
    private Button boton_guardar;
	private Button boton_cancelar;
    

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		
		super.onCreate(savedInstanceState);
		setData();
		mAdapter = new MyAdapter(this);
		setListAdapter (mAdapter);
      
	}
	public void doPositiveClick(){
        Toast.makeText(this, "Ha pulsado OK", Toast.LENGTH_SHORT).show();
    }
     
    public void doNegativeClick(){
        Toast.makeText(this, "Ha pulsado Cancelar", Toast.LENGTH_SHORT).show();
    }
 

	@Override
	protected void  onListItemClick(ListView lv, View v, int position, long id){
		 super.onListItemClick(lv, v, position, id);
			 switch (position) {
			 case 0:
				salir3();

				 return;
			 case 1:
				 salir2();
				 return;
			 case 2:
				 finish();
					Intent i = new Intent(this, PerfilFormulario.class);
					 System.out.println ("Intentamos visualizar");
					i.putExtra(C_MODO, C_VISUALIZAR);
				
					startActivityForResult(i, C_VISUALIZAR);
				return;			
			 }
			}
		
	private MyAdapter mAdapter = null;
	public class Node
	{
		public String mTitle;
		public Integer mImageResource;
		public String mhorario;
		public String medades;
	}
	private static ArrayList<Node> mArray = new ArrayList<Node>();
	
	private void setData(){
		mArray.clear();
	
		Node mynode0 = new Node();
		mynode0.mTitle = "Borrar solo las tomas";
		mynode0.mImageResource = R.drawable.idelete; //Aqui me creo las imagenes
		mynode0.mhorario = "Borra todas las tomas ";
		mynode0.medades = " ";
		mArray.add(mynode0);
		
		
		Node mynode1 = new Node();
		mynode1.mTitle = "Eliminar medicinas y tomas";
		mynode1.mImageResource = R.drawable.irestablecer; //Aqui me creo las imagenes
		mynode1.mhorario = "Elimina todas las medicinas y tomas";
		mynode1.medades = "";
		mArray.add(mynode1);
		
		Node mynode2 = new Node();
		mynode2.mTitle = "Perfil";
		mynode2.mImageResource = R.drawable.iperfil; //Aqui me creo las imagenes
		mynode2.mhorario = "Nombre usuario y telefono emergencia";
		mynode2.medades = "";
		mArray.add(mynode2);
		
		
		}
	private void volverFabrica(){
		borrarTodos();
		MedicinaDbAdapter dbMAdapter = new MedicinaDbAdapter(this);
        dbMAdapter.abrir();
        String filtro="";
       
        MedicinaAdaptador MedicinaAdapter = new MedicinaAdaptador (this, dbMAdapter.getMedicinas(filtro));
       
	       	  
	       	    Log.d("TomasEliminadas",  Integer.toString(MedicinaAdapter.getCount()));
	       	    
	       		 Medicina m;

	       	    for (int i=0; i<MedicinaAdapter.getCount(); i++){
	       	    	m = MedicinaAdapter.getItem(i);
	       	    	m.delete();
	       	    
	       	    }
	       	     Log.d("Filtro", filtro);
	        dbMAdapter.cerrar();
	               
        
	}
	
	private void salir2() {
        new AlertDialog.Builder(this).setTitle("Esta seguro que quiere borrar todos")
            .setPositiveButton("Si", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface arg0, int arg1) {
                //finish();  
                	 volverFabrica();
                }
            })
            .setNegativeButton("No", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface arg0, int arg1) {
                    
                }
            }).show();
    }
	private void salir3() {
        new AlertDialog.Builder(this).setTitle("Esta seguro que quiere borrar todos")
            .setPositiveButton("Si", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface arg0, int arg1) {
              //  finish();  
                	 borrarTodos();
                }
            })
            .setNegativeButton("No", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface arg0, int arg1) {
                    
                }
            }).show();
    }
	
	 private void borrarTodos(){
		 //Elimina todas las medicinas y tomas del la aplicacin
			TomaDbAdapter dbAdapter4 = new TomaDbAdapter(this);
			  dbAdapter4.abrir();
   	        String filtro = new String(""); 
   	      	       	    Log.d("Filtro",  filtro);
   	       	   TomaAdapter TomasAdapter = new TomaAdapter(this, dbAdapter4.getTomas2(filtro));
   	       	    Log.d("TomasEliminadas",  Integer.toString(TomasAdapter.getCount()));
   	       	   	       		 Toma t;

   	       	    for (int i=0; i<TomasAdapter.getCount(); i++){
   	       	    	t = TomasAdapter.getItem(i);
   	       	    	t.delete();
   	       	      	       	    
   	       	    	
   	       	    }
   	       	   
   	        dbAdapter4.cerrar();
		 }   	  
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
	
		getMenuInflater().inflate(R.menu.menu_configuracion, menu);
		return true;
	}
	

	
	
	public static class MyAdapter extends BaseAdapter{
		private Context mContext;
		public MyAdapter (Context c){mContext = c;}
		
		
		public int getCount() {
		// TODO Auto-generated method stub
			return mArray.size();
		}
		
		
		public Object getItem(int position) {
		// TODO Auto-generated method stub
			return mArray.get(position);
		}
		
		
		public long getItemId(int position) {
		// TODO Auto-generated method stub
			return 0;}
		
		
		public View getView(int position, View convertView, ViewGroup parent) {
		// TODO Auto-generated method stub
			View view = null;
			if (convertView == null){
					LayoutInflater inflater = (LayoutInflater) 
							mContext.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
					view = inflater.inflate(R.layout.activity_principal, null);
			}else{
				view = convertView;
			}
			
			ImageView img = (ImageView) (ImageView) view.findViewById(R.id.logo);
			img.setImageDrawable 
			(mContext.getResources().getDrawable(mArray.get(position).mImageResource));
			
			TextView tTitle = (TextView) view.findViewById(R.id.nomPelicula);
			tTitle.setText(mArray.get(position).mTitle);
			
			TextView hTitle = (TextView) view.findViewById(R.id.horaPelicula);
			hTitle.setText(mArray.get(position).mhorario);
			
			TextView eTitle = (TextView) view.findViewById(R.id.edadesPelicula);
			eTitle.setText(mArray.get(position).medades);
			
			
			return view;
		}
		}
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		switch (item.getItemId()){
		
			case R.id.perfil:
			finish();
				Intent i = new Intent(this, PerfilFormulario.class);
				 System.out.println ("Intentamos visualizar");
				i.putExtra(C_MODO, C_VISUALIZAR);
			
				startActivityForResult(i, C_VISUALIZAR);
			
				return true;
			
			case R.id.salir:
				finish();
				Intent i2 = new Intent(this, PantallaPrincipal.class);
				
				startActivityForResult(i2, C_VISUALIZAR);
			
				return true;
		default:
			return super.onOptionsItemSelected(item);
		}
	}
}
