package controlador;



import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.GregorianCalendar;

import com.pillcontrol.medicinas.R;
import com.pillcontrol.medicinas.R.id;
import com.pillcontrol.medicinas.R.layout;
import com.pillcontrol.medicinas.R.menu;
import com.pillcontrol.medicinas.R.string;

import modelo.HistorialAdapter;
import modelo.HoyAdapter;
import modelo.TomaAdapter;
import modelo.TomaDbAdapter;
import modelo.PasadasAdapter;


import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;

import android.view.Menu;
import android.view.MenuItem;
import android.view.View;

import android.widget.AdapterView.AdapterContextMenuInfo;
import android.widget.ListView;





public class HoyActivity extends ListActivity{
	
    public static final String C_MODO  = "modo" ;
    public static final int C_VISUALIZAR = 551 ;
    public static final int C_CREAR = 552 ;
    public static final int C_EDITAR = 553 ;
    public static final int C_ELIMINAR = 554 ;
    public static final int C_CONFIGURAR = 555 ;
    public static final int C_VOLVER = 556 ;	
    public static final int C_HOY = 560 ;	
    public static final int C_PASADAS = 561 ;	
    public static final int C_HISTORIAL = 562 ;
    public static final int C_BOTONERA = 557 ;
	private TomaDbAdapter dbAdapter;
    private TomaAdapter TomasAdapter ;
    private HistorialAdapter HistorialAdapter;
    private PasadasAdapter PasadasAdapter;
    private ListView lista;
    private String filtro ;
    private int modo ;
    private int vista;
	
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_toma);
        Intent intent = getIntent();
        Bundle extra = intent.getExtras();
		//setContentView(R.layout.activity_medicina_formulario);

    
	establecerModo(extra.getInt(PantallaPrincipal.C_MODO));
	  lista = (ListView) findViewById(android.R.id.list);

      dbAdapter = new TomaDbAdapter(this);
      dbAdapter.abrir();
      
      SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy"); 
      Calendar c1 = GregorianCalendar.getInstance();
       String dia1=sdf.format(c1.getTime());  
       c1.add(Calendar.DATE, 1);
       String dia2=sdf.format(c1.getTime());
	
    if(vista==1){ //hoy
    
    	filtro = new String("hip_tomada = 0 and hip_fecha LIKE " + "'" + dia1 + "'");
    	consultar();
    }
    if(vista==2){ //pasadas
    	
    	SimpleDateFormat larga = new SimpleDateFormat("yyyy/M/d HH:mm:ss:ss"); 
        Calendar c3 = GregorianCalendar.getInstance();
         String dia3=larga.format(c3.getTime());  
         c3.add(Calendar.DATE, -10);
         String dia4=larga.format(c3.getTime());
	
        
        
     
	     
	     filtro = new String("hip_tomada = 0 and hip_flarga BETWEEN " + "'" + dia4 + "'" + " AND "  + "'" + dia3 + "'");
    	 pasadas();
    }
    if(vista==3){ //historial
    	 filtro = new String("hip_tomada = 1" );
    	 historial();
    }

  
        
       registerForContextMenu(this.getListView());
       
      
       
       
    }

    public void consultar()
    {
        TomasAdapter = new TomaAdapter(this, dbAdapter.getTomas(filtro));

        lista.setAdapter(TomasAdapter);
    }
    public void pasadas()
    {
    	
    	TomasAdapter = new TomaAdapter(this, dbAdapter.getTomasPasadas(filtro));

        lista.setAdapter(TomasAdapter);
    }	
    public void historial()
    {
    	HistorialAdapter = new HistorialAdapter(this, dbAdapter.getTomasDesc(filtro));

        lista.setAdapter(HistorialAdapter);
    }	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.toma, menu);
		return true;
	}
	private void establecerModo(int m)
	 {
	        this.modo = m ;

	        if (modo == PantallaPrincipal.C_HOY)
	        {
	            this.setTitle("Tomas para hoy");
	            vista=1;
	        }
	        else if (modo == PantallaPrincipal.C_PASADAS)
	        {
	          this.setTitle("Tomas olvidadas ");
	          getActionBar().setTitle("Tomas olvidadas");
	          vista=2;
	        }
	        if (modo == PantallaPrincipal.C_HISTORIAL)
	        {
	            this.setTitle("Medicinas ya tomadas");
	            vista=3;
	        }
	       
	    }
	
	
	protected void onListItemClick(ListView l, View v, int position, long id)
	{
		super.onListItemClick(l, v, position, id);
		
		visualizar(id);
	}
	private void visualizar(long id)
	{
		// Llamamos a la Actividad TomaFormulario indicando el modo visualización y el identificador del registro 
		
	
		 if (vista==3){
			// Llamamos a la Actividad TomaFormulario indicando el modo visualización y el identificador del registro 
				Intent i = new Intent(HoyActivity.this, TomaFormulario.class);
				
				i.putExtra(C_MODO, C_BOTONERA);
				i.putExtra(TomaDbAdapter.C_COLUMNA_ID, id);
								
				startActivityForResult(i, C_BOTONERA);
			
		 }else{
			 Intent i = new Intent(HoyActivity.this, TomaFormulario.class);
			 i.putExtra(C_MODO, C_VISUALIZAR);
		i.putExtra(TomaDbAdapter.C_COLUMNA_ID, id);
				
		startActivityForResult(i, C_VISUALIZAR);}
			finish();
		
	}
    @Override
    public boolean onMenuItemSelected(int featureId, MenuItem item)
    {
        Intent i;

        switch (item.getItemId())
        {
        case R.id.menu_volver:
      
        	i = new Intent(HoyActivity.this, PantallaPrincipal.class);
            startActivityForResult(i, C_CONFIGURAR);
        	finish();
        	return true;
        	
        }
        return super.onMenuItemSelected(featureId, item);
    }
	
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data)
    {
        //
        // Nos aseguramos que es la petición que hemos realizado
        //
        switch(requestCode)
        {
            case C_CREAR:
                if (resultCode == RESULT_OK)
                    consultar();

            case C_VISUALIZAR:
                if (resultCode == RESULT_OK)
                    consultar();
            case C_VOLVER:
               finish();
               
            case C_CONFIGURAR:
                // en la PreferenceActivity no hemos definido ningún resultado por lo que recargamos
                // siempre las preferencias
    //         getPreferencias();
                consultar();

            default:
                super.onActivityResult(requestCode, resultCode, data);
        }
    }
	
	private void borrar(final long id)
	{
		/*
		 * Borramos el registro y refrescamos la lista
		 */
		AlertDialog.Builder dialogEliminar = new AlertDialog.Builder(this);
		
		dialogEliminar.setIcon(android.R.drawable.ic_dialog_alert);
	//	
		dialogEliminar.setCancelable(false);
		
		dialogEliminar.setPositiveButton(getResources().getString(android.R.string.ok), new DialogInterface.OnClickListener() {

			public void onClick(DialogInterface dialog, int boton) {
				dbAdapter.delete(id);
				//Toast.makeText(TomaActivity.this, R.string.Toma_eliminar_confirmacion, Toast.LENGTH_SHORT).show();
				consultar();				
			}
		});
		
		dialogEliminar.setNegativeButton(android.R.string.no, null);
		
		dialogEliminar.show();
	}

	@Override
	public void onCreateContextMenu(ContextMenu menu, View v, ContextMenuInfo menuInfo) {
		super.onCreateContextMenu(menu, v, menuInfo);

		menu.setHeaderTitle(TomasAdapter.getItem(((AdapterContextMenuInfo) menuInfo).position).getFecha());
		menu.add(Menu.NONE, C_VISUALIZAR, Menu.NONE, R.string.menu_visualizar);
		menu.add(Menu.NONE, C_EDITAR, Menu.NONE, R.string.menu_editar);
		menu.add(Menu.NONE, C_ELIMINAR, Menu.NONE, R.string.menu_eliminar);
		menu.add(Menu.NONE, C_VOLVER, Menu.NONE, R.string.menu_atras);
	}
	
	@Override
	public boolean onContextItemSelected(MenuItem item) {
		
		AdapterContextMenuInfo info = (AdapterContextMenuInfo) item.getMenuInfo();
		Intent i;
		
		switch(item.getItemId())
		{
	    	case C_ELIMINAR:
	    		borrar(info.id);
	    		return true;
	    	
	    	case C_VISUALIZAR:
	    		visualizar(info.id);
				return true;
				
	    	case C_EDITAR:
	    		i = new Intent(HoyActivity.this, TomaFormulario.class);
	    		i.putExtra(C_MODO, C_EDITAR);
	    		i.putExtra(TomaDbAdapter.C_COLUMNA_ID, info.id);
				
	    		startActivityForResult(i, C_EDITAR);
				return true;
				
	    	case C_VOLVER:
	    		cancelar();
	    		return true;
	    		
	    }
	    return super.onContextItemSelected(item);
	}
	private void cancelar()
	{
		setResult(RESULT_CANCELED, null);
		finish();
	}
	
	
}
