package controlador;


import com.pillcontrol.medicinas.R;

import modelo.Perfil;
import modelo.PerfilDbAdapter;


import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.Toast;

public class PerfilFormulario extends Activity {
	
//	private SituacionDbAdapter dbAdapterSituacion ;
  //  private SituacionSpinnerAdapter situacionSpinnerAdapter ;

	//
    // Modo del formulario
    //
	private int modo ;
	
	//
	// Identificador del registro que se edita cuando la opción es MODIFICAR
	//
	private long id ;
    private Perfil perfil = new Perfil(this);
	
    //
    // Elementos de la vista
    //
    private EditText name;
    private EditText fNacimiento;
    private EditText edad;
    private EditText usuario;
    private EditText passwd;
    
	
	private Button boton_guardar;
	private Button boton_cancelar;



	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.activity_perfil_formulario);
		
		Intent intent = getIntent();
		Bundle extra = intent.getExtras();

		if (extra == null) return;
		
        //
        // Obtenemos los elementos de la vista
        //
       name = (EditText) findViewById(R.id.name);
        fNacimiento = (EditText) findViewById(R.id.fNacimiento);
        edad = (EditText) findViewById(R.id.edad);
        usuario = (EditText) findViewById(R.id.usuario);
 
        passwd = (EditText) findViewById(R.id.passwd);
       
		boton_guardar = (Button) findViewById(R.id.boton_guardar);
		boton_cancelar = (Button) findViewById(R.id.boton_cancelar);

       
		consultar(1);
		//
		// Establecemos el modo del formulario
		//
		
		establecerModo(extra.getInt(PerfilActivity.C_MODO));
		
		//
		// Definimos las acciones para los dos botones
		//
		boton_guardar.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v)
			{
				guardar();
			}
		});
		
		boton_cancelar.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v)
			{
				cancelar();	
			}
		});
		
	}
	
    private void establecerModo(int m)
    {
        this.modo = m ;

        if (modo == PerfilActivity.C_VISUALIZAR)
        {
            this.setTitle(name.getText().toString());
            this.setEdicion(false);
        }
        else if (modo == PerfilActivity.C_CREAR)
        {
            this.setTitle(R.string.perfil_crear_titulo);
            this.setEdicion(true);
        }
        else if (modo == PerfilActivity.C_EDITAR)
        {
            this.setTitle(R.string.perfil_editar_titulo);
            this.setEdicion(true);
        }
    }
	
private void consultar(long id)
{
    //
    // Consultamos la perfil por el identificador
    //
	 
	   
    perfil = Perfil.find(this, id);
  
  
   name.setText(perfil.getNombre());
    fNacimiento.setText(perfil.getfNacimiento());
    edad.setText(perfil.getEdad());
   usuario.setText(perfil.getUsuario());
  
   
   passwd.setText(perfil.getPasswd());
  

}

private void setEdicion(boolean opcion)
{
	
    name.setEnabled(opcion);
    fNacimiento.setEnabled(opcion);
    edad.setEnabled(opcion);
    usuario.setEnabled(opcion);
  
    passwd.setEnabled(opcion);
   

    // Controlamos visibilidad de botonera
    LinearLayout v = (LinearLayout) findViewById(R.id.botoneraPerfil);

  if (opcion)
        v.setVisibility(View.VISIBLE);

   else
        v.setVisibility(View.GONE);
        
}
	
private void guardar()
{
	
    perfil.setNombre(name.getText().toString());
    perfil.setfNacimiento(fNacimiento.getText().toString());
    perfil.setEdad(edad.getText().toString());
    perfil.setUsuario(usuario.getText().toString());
    perfil.setPasswd(passwd.getText().toString());
    
  

    perfil.save();

    if (modo == PerfilActivity.C_CREAR)
    {
        Toast.makeText(PerfilFormulario.this, R.string.perfil_crear_confirmacion, Toast.LENGTH_SHORT).show();
    }
    else if (modo == PerfilActivity.C_EDITAR)
    {
        Toast.makeText(PerfilFormulario.this, R.string.perfil_editar_confirmacion, Toast.LENGTH_SHORT).show();
    }

    //
    // Devolvemos el control
    //
    setResult(RESULT_OK);
    finish();
}
	
	private void cancelar()
	{
		setResult(RESULT_CANCELED, null);
		finish();
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		menu.clear();
	    
		if (modo == PerfilActivity.C_VISUALIZAR)
			getMenuInflater().inflate(R.menu.perfil_formulario_ver, menu);
		
		else
			getMenuInflater().inflate(R.menu.perfil_formulario_editar, menu);
		
		return true;
	}
	
@Override
public boolean onMenuItemSelected(int featureId, MenuItem item) {
	
	switch (item.getItemId())
	{
		/*case R.id.menu_eliminar:
			borrar(id);
			return true;*/
			
		case R.id.menu_cancelar:
			finish();
	
		    Intent actividad3 = new Intent (this,PantallaPrincipal.class);
		    
		    startActivity(actividad3); 
			return true;
			
		case R.id.menu_guardar:
			guardar();
			return true;
		case R.id.salir:
			 finish();
		case R.id.menu_atras:
			finish();
			Intent actividad4 = new Intent (this,PantallaPrincipal.class);
		    
		    startActivity(actividad4);
		 
		 
		 //default:
			// return super.onOptionsItemSelected(item);
			
		case R.id.menu_editar:
		establecerModo(PerfilActivity.C_EDITAR);
			return true;
	}
	
	return super.onMenuItemSelected(featureId, item);
}
	
	
}