package modelo;

import android.content.Context;
import android.graphics.Color;
import android.net.ParseException;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;


import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;



public class HoyAdapter extends ArrayAdapter<Toma>
{
    private static class ViewHolder {
        TextView text1;
        TextView text2;
    }

    public HoyAdapter(Context context, ArrayList<Toma> tomas) {
    	
        super(context, android.R.layout.simple_list_item_2, tomas);
       
    }
    

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {

        Toma toma = getItem(position);

        ViewHolder viewHolder;

        if (convertView == null)
        {
            viewHolder = new ViewHolder();
            LayoutInflater inflater = LayoutInflater.from(getContext());
            //convertView = inflater.inflate(android.R.layout.simple_dropdown_item_line, parent, false);
            convertView = inflater.inflate(android.R.layout.simple_list_item_2, parent, false);
            viewHolder.text1 = (TextView) convertView.findViewById(android.R.id.text1);
            viewHolder.text2 = (TextView) convertView.findViewById(android.R.id.text2);
            convertView.setTag(viewHolder);
        }
        else
        {
            viewHolder = (ViewHolder) convertView.getTag();
        }
      
     
        StringBuilder texto =new StringBuilder().append("").append(toma.getNombreMedicamento())    ;
       
     ;
        
  
       
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy/M/d HH:mm:ss:ss"); 
        Calendar c1 = GregorianCalendar.getInstance();
       
         String dia1=sdf.format(c1.getTime());  
         long horas = diferenciaFechas(dia1, toma.getFlarga());
         
         viewHolder.text1.setTextColor(Color.parseColor("#000000"));
         if ((horas<=60)&&(horas>=0))
        	 	viewHolder.text1.setTextColor(Color.parseColor("#469202"));
         else if ((horas>62) && (horas<=120))
        	 viewHolder.text1.setTextColor(Color.parseColor("#F28220"));
         else if( horas >=121)
         		viewHolder.text1.setTextColor(Color.parseColor("#000000"));
         else if (horas<0){
        	 viewHolder.text1.setTextColor(Color.RED);
        	 
         }
         viewHolder.text1.setText(texto);
         viewHolder.text2.setText("Hora: "+ toma.getHora() + "h  " + "Da : " + toma.getFecha());
        return convertView;
    }
    public long diferenciaFechas(String inicio, String llegada){

       Date fechaInicio = null;
       Date fechaLlegada = null;

        
       SimpleDateFormat formato = new SimpleDateFormat("yyyy/M/d hh:mm:ss:ss");

        try {
           // aca realizamos el parse, para obtener objetos de tipo Date de 
           // las Strings
           fechaInicio = formato.parse(inicio);
           fechaLlegada = formato.parse(llegada);

        } catch (ParseException e) {
          // Log.e(TAG, "Funcion diferenciaFechas: Error Parse " + e);
       } catch (Exception e){
           // Log.e(TAG, "Funcion diferenciaFechas: Error " + e);
       }

        // tomamos la instancia del tipo de calendario
       Calendar calendarInicio = Calendar.getInstance();
       Calendar calendarFinal = Calendar.getInstance();

        // Configramos la fecha del calendatio, tomando los valores del date que 
       // generamos en el parse
       calendarInicio.setTime(fechaInicio);
       calendarFinal.setTime(fechaLlegada);

        // obtenemos el valor de las fechas en milisegundos
       long milisegundos1 = calendarInicio.getTimeInMillis();
       long milisegundos2 = calendarFinal.getTimeInMillis();

        // tomamos la diferencia
       long diferenciaMilisegundos = milisegundos2 - milisegundos1;

        // Despues va a depender en que formato queremos  mostrar esa 
       // diferencia, minutos, segundo horas, dias, etc, aca van algunos 
       // ejemplos de conversion

        // calcular la diferencia en segundos
       long diffSegundos =  Math.abs (diferenciaMilisegundos / 1000);

        // calcular la diferencia en minutos
       long diffMinutos =  Math.abs (diferenciaMilisegundos / (60 * 1000));
       long restominutos = diffMinutos%60;

        // calcular la diferencia en horas
       long diffHoras =   (diferenciaMilisegundos / (60 * 60 * 1000));

        // calcular la diferencia en dias
       long diffdias = Math.abs ( diferenciaMilisegundos / (24 * 60 * 60 * 1000) );

        // devolvemos el resultado en un string
       return diffMinutos;
    }
    @Override
    public long getItemId(int position)
    {
        return getItem(position).getId();
    }
}
