package modelo;



import java.sql.Date;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;









import android.app.AlarmManager;
import android.app.AlertDialog;
import android.app.ListActivity;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.ContentValues;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.support.v4.app.NotificationCompat;
import android.util.Log;
import android.widget.ListView;
import android.widget.Toast;


public class Medicina extends ListActivity{

    private Context context;

    private Long id;
    private String nombre;
    private String descripcion;
    private String cantidad;
    private Integer tomarCada;
    private String horaInicio;
    private String efectosSecundarios;
    private String observaciones;
    private Integer duracion;
    private String fechaInicio;
    private String cronico;
    private String ultimaGeneracion;
    private String ultimaHora;
    
    
    private Toma[] tomas;
    
    
    private Date fechaLarga;
   
    private SimpleDateFormat date;
    private SimpleDateFormat hour;

    private static final int opcion1 = 1;
	private static PendingIntent pendingIntent=null;
	private static final int ALARM_REQUEST_CODE = 1;
	

    public Medicina(Context context)
    {
        this.context = context;
    }
   
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
       // setContentView(R.layout.activity_medicina);
 
    }

    
    
    
    public Medicina(Context context, Long id, String nombre, String descripcion, String cantidad, Integer tomarCada, String horaInicio, String efectosSecundarios, String observaciones, Integer duracion, String cronico, String ultima, String ultimaHora, String fechaInicio) {
        this.context = context;
        this.id = id;
        this.nombre = nombre;
        this.descripcion = descripcion;
        this.cantidad = cantidad;
        this.tomarCada = tomarCada;
        this.efectosSecundarios = efectosSecundarios;
        this.observaciones = observaciones;
        this.horaInicio = horaInicio;
        this.duracion = duracion;
        this.fechaInicio = fechaInicio;
        this.setCronico(cronico);
        this.setFechaLarga(new Date(System.currentTimeMillis()));
        this.date = new SimpleDateFormat("yyyy/M/d");
        this.hour = new SimpleDateFormat("HH:mm:ss:ss");
        this.setUltimaGeneracion(ultima);
        this.setUltimaHora(ultimaHora);
        
       // this.tomas = new Toma[100];
        
      
       
    }
    public void crearFechaLarga() throws ParseException{
    	
    	
    	SimpleDateFormat sdf = new SimpleDateFormat("yyyy/M/d HH:mm:ss:ss");
    	String stringFechaConHora = this.date + " " + this.hour;
    //	System.out.println(stringFechaConHora);
    	this.setFechaLarga((Date) sdf.parse(stringFechaConHora));
    }

    public Context getContext() {
        return context;
    }

    public void setContext(Context context) {
        this.context = context;
    }

    public Long getId() {
        return id;
    }
    public void ampliarDuracion (){
    	//metodo utilizado para ampliar indefinidamente las pastillas cronicas cuando se queden sin dosis
    	
    	Calendar fechaInicioNueva =  Calendar.getInstance();
    	 String fechaInicioAnt= this.getFechaInicio();
    	 int duracion = 30;
    	 this.setDuracion(duracion);
    	 
    	 String horaInicioAnt= this.getHoraInicio();
    	 this.setFechaInicio(this.getUltimaGeneracion());
    	 this.setHoraInicio(this.getUltimaHora());
 		this.setHoraInicio(horaInicioAnt);
		
		crearTomas();
		//generadas las tomas volvemos a dejar la tomas como al principio.
		this.setFechaInicio(fechaInicioAnt);
		this.setHoraInicio(horaInicioAnt);
					
		//	 to = new Toma(this.context,cantidad, sdf2.format(fechaToma.getTime()), sdf3.format(fechaToma.getTime()) , false, this.id, this.nombre, false, "2014-08-12 22:12:0"); 
    	 
    	 
    	
    	
    }
    public void setId(Long id) {
        this.id = id;
    }

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

	public String getDescripcion() {
		return descripcion;
	}

	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}

	public String getCantidad() {
		return cantidad;
	}

	public void setCantidad(String cantidad) {
		//Ampliamos la duracin del tratamiento
		SimpleDateFormat hoy = new SimpleDateFormat("dd/MM/yyyy");
		Calendar fechaToma =  Calendar.getInstance();
	
		if (this.getCronico()!=null)
			if ((this.getCronico().equals("SI"))){
				
				//&&
				if	(this.getUltimaGeneracion().equals("27/06/2015")){
					//hoy.format(fechaToma.getTime())
					ampliarDuracion();}
			}
			
		this.cantidad = cantidad;
	}

	
	public Integer getTomarCada() {
		return tomarCada;
	}

	public void setTomarCada(Integer tomarCada) {
		this.tomarCada = tomarCada;
	}

	public String getEfectosSecundarios() {
		return efectosSecundarios;
	}

	public void setEfectosSecundarios(String efectosSecundarios) {
		this.efectosSecundarios = efectosSecundarios;
	}

	public String getObservaciones() {
		return observaciones;
	}

	public void setObservaciones(String observaciones) {
		this.observaciones = observaciones;
	}

  
	
    public static Medicina find(Context context, long id)
    {
    	
    	
    	MedicinaDbAdapter dbAdapter = new MedicinaDbAdapter(context);

        Cursor c = dbAdapter.getRegistro(id);

        Medicina medicina = Medicina.cursorToMedicina(context, c);

        c.close();

        return medicina;
    }

    public static Medicina cursorToMedicina(Context context, Cursor c)
    {
        Medicina medicina = null;

        if (c != null)
        {
            medicina = new Medicina(context);

            medicina.setId(c.getLong(c.getColumnIndex(MedicinaDbAdapter.C_COLUMNA_ID)));
            medicina.setNombre(c.getString(c.getColumnIndex(MedicinaDbAdapter.C_COLUMNA_NOMBRE)));
            medicina.setDescripcion(c.getString(c.getColumnIndex(MedicinaDbAdapter.C_COLUMNA_DESCRIPCION)));
            medicina.setCantidad(c.getString(c.getColumnIndex(MedicinaDbAdapter.C_COLUMNA_CANTIDAD)));
            
            String cad = c.getString(c.getColumnIndex(MedicinaDbAdapter.C_COLUMNA_TOMARCADA));
            
            Integer cada = Integer.parseInt(cad);

            String dur = c.getString(c.getColumnIndex(MedicinaDbAdapter.C_COLUMNA_DURACION));
            
            Integer dura = Integer.parseInt(dur);
            
            
            String hor = c.getString(c.getColumnIndex(MedicinaDbAdapter.C_COLUMNA_HORAINICIO));
            String ul = c.getString(c.getColumnIndex(MedicinaDbAdapter.C_COLUMNA_ULTIMAGENERACION));
            String ul2 = c.getString(c.getColumnIndex(MedicinaDbAdapter.C_COLUMNA_ULTIMAHORA));
            medicina.setTomarCada(cada);
            medicina.setDuracion(dura);
            medicina.setHoraInicio(hor);
            medicina.setEfectosSecundarios(c.getString(c.getColumnIndex(MedicinaDbAdapter.C_COLUMNA_EFECTOSSECUNDARIOS)));
            medicina.setObservaciones(c.getString(c.getColumnIndex(MedicinaDbAdapter.C_COLUMNA_OBSERVACIONES)));
            medicina.setFechaInicio(c.getString(c.getColumnIndex(MedicinaDbAdapter.C_COLUMNA_FINICIO)));
            medicina.setUltimaGeneracion(ul);
            medicina.setUltimaHora(ul2);
            //medicina.setUltimaHora(c.getString(c.getColumnIndex(MedicinaDbAdapter.C_COLUMNA_ULTIMAHORA)));
            medicina.setCronico(c.getString(c.getColumnIndex(MedicinaDbAdapter.C_COLUMNA_CRONICO)));
            
     
        }

        return medicina ;
    }
    
  
    private ContentValues toContentValues()
    {
        ContentValues reg = new ContentValues();

        reg.put(MedicinaDbAdapter.C_COLUMNA_ID, this.getId());
        reg.put(MedicinaDbAdapter.C_COLUMNA_NOMBRE, this.getNombre());
        reg.put(MedicinaDbAdapter.C_COLUMNA_DESCRIPCION, this.getDescripcion());
        reg.put(MedicinaDbAdapter.C_COLUMNA_CANTIDAD, this.getCantidad());
        reg.put(MedicinaDbAdapter.C_COLUMNA_TOMARCADA, this.getTomarCada());
        reg.put(MedicinaDbAdapter.C_COLUMNA_EFECTOSSECUNDARIOS, this.getEfectosSecundarios());
        reg.put(MedicinaDbAdapter.C_COLUMNA_OBSERVACIONES, this.getObservaciones());
        reg.put(MedicinaDbAdapter.C_COLUMNA_DURACION, this.getDuracion());
        reg.put(MedicinaDbAdapter.C_COLUMNA_HORAINICIO, this.getHoraInicio());
        reg.put(MedicinaDbAdapter.C_COLUMNA_FINICIO, this.getFechaInicio());
        reg.put(MedicinaDbAdapter.C_COLUMNA_ULTIMAGENERACION, this.getUltimaGeneracion());
        reg.put(MedicinaDbAdapter.C_COLUMNA_ULTIMAHORA, this.getUltimaHora());
        reg.put(MedicinaDbAdapter.C_COLUMNA_FINICIO, this.getFechaInicio());
        if (this.getCronico()==null)
        		this.setCronico("FL");
        reg.put(MedicinaDbAdapter.C_COLUMNA_CRONICO, this.getCronico());

        return reg;
    }

    public long save()
    {
        MedicinaDbAdapter dbAdapter = new MedicinaDbAdapter(this.getContext());
        
     
        if ((this.getId() == null) || (!dbAdapter.exists(this.getId())))
        {
            long nuevoId = dbAdapter.insert(this.toContentValues());

            if (nuevoId != -1)
            {
                this.setId(nuevoId);
            }
        }
        else
        {
            dbAdapter.update(this.toContentValues());
        }

        return this.getId();
    }

    public long delete()
    {
        // borramos el registro
        MedicinaDbAdapter dbAdapter = new MedicinaDbAdapter(this.getContext());
     
        return dbAdapter.delete(this.getId());
    }

	public Integer getDuracion() {
		return duracion;
	}

	public void setDuracion(Integer duracion) {
		this.duracion = duracion;
	}

	public String getHoraInicio() {
		return horaInicio;
	}

	public void setHoraInicio(String horaInicio) {
		this.horaInicio = horaInicio;
	}


	public String getFechaInicio() {
		return fechaInicio;
	}


	public void setFechaInicio(String fechaInicio) {
		this.fechaInicio = fechaInicio;
	}


	

	


	public Toma[] getTomas() {
		return tomas;
	}


	public void setTomas(Toma[] tomas) {
		this.tomas = tomas;
	}
	public void crearTomas(){
		int i=0;
		int tomas_cada_dia=24/this.tomarCada;
		double tomas_totales=tomas_cada_dia*this.duracion;
		
		
		String horaAnterior;
		String fechaAnterior;
		int horaAnterioInt;
		int horaNueva;
		int dia=0;
		int year=0;
		int mes=0;
		int hora = 17;
		int min = 32;
		int seg = 0;
		int cantidad = Integer.parseInt(this.cantidad);
		Calendar fechaToma;
		 int longitud = this.fechaInicio.length();
		 System.out.println("Fecha inicio tratamiento: " + this.getFechaInicio());
		 System.out.println("Hora inicio tratamiento: " + this.getHoraInicio());
		 System.out.println("Tomas totales");
		// partirfecha(this.fechaInicio, dia, mes, year);
		 System.out.println("Dia:" + dia + "mes: " + mes + " year " + year);
		if (longitud==10){
			 dia = Integer.parseInt(this.fechaInicio.substring(0, 2));
			 mes = Integer.parseInt(this.fechaInicio.substring(3, 5));
			 year= Integer.parseInt(this.fechaInicio.substring(6, 10));
		}else if(longitud==8){
			dia = Integer.parseInt(this.fechaInicio.substring(0, 0));
			 mes = Integer.parseInt(this.fechaInicio.substring(2, 2));
			 year= Integer.parseInt(this.fechaInicio.substring(4,7));
				}else{ if(this.fechaInicio.indexOf("-")==1){
							 dia = Integer.parseInt(this.fechaInicio.substring(0, 0));
							 mes = Integer.parseInt(this.fechaInicio.substring(2, 3));
							 year= Integer.parseInt(this.fechaInicio.substring(5,8));
						}else
						{
							 dia = Integer.parseInt(this.fechaInicio.substring(0, 1));
							 mes = Integer.parseInt(this.fechaInicio.substring(3, 3));
							 year= Integer.parseInt(this.fechaInicio.substring(5, 8));
						}
					
				}
		// partirhora(this.horaInicio, hora, min);
		longitud = this.horaInicio.length();
		if (longitud==5){
			 hora = Integer.parseInt(this.horaInicio.substring(0, 2));
			 min = Integer.parseInt(this.horaInicio.substring(3, 5));
			 
			
		}
		
		
		fechaToma =  Calendar.getInstance();
		fechaToma.set(year,mes-1,dia,hora,min,seg);
		String fechass = new String(year + "-" + mes + "" + dia); 
		Date inicio = new Date( year, mes, dia);
		Toma to = new Toma(this.context,cantidad, this.fechaInicio, this.horaInicio, false, this.id, this.nombre, false, "2014-08-12 22:12:0"); 
	
		to.setFlarga(dia, mes, year, hora, min);
		to.setFoto(this.getDescripcion());
		
		to.setId_medicamento(this.id);
		to.save();
		String hor = horaInicio.toString();
	    
	  
	    String digito1 = hor.substring(0, 1);
	    String digito2 = hor.substring(1,2);
	    String dospuntos = "::";
	    String dos = dospuntos.substring(0, 1);
	 hora = 12;
	    if (digito2.compareTo(dos)==0)
	    		 hora = Integer.parseInt(hor.substring(0, 1));
	    else
	    	hora = Integer.parseInt(hor.substring(0, 2));

	int  primeraHora=hora; 
	int  siguienteToma=0;
	
	for(i=1; i<=tomas_totales; i++){
					
			horaNueva = fechaToma.get(Calendar.HOUR_OF_DAY) + this.getTomarCada();
			if (horaNueva>23)
				{
					//cambio de dia sumar un dia a la fecha
					horaNueva=horaNueva-24;
					fechaToma.add(Calendar.HOUR_OF_DAY, this.getTomarCada());
					//System.out.println("Hora DESPUES de sumar la hora:  " + fechaToma.get(Calendar.HOUR_OF_DAY));			
				}
			else
				{
					fechaToma.add(Calendar.HOUR_OF_DAY, this.getTomarCada());
					//System.out.println("Hora DESPUES de sumar la hora:  " + fechaToma.get(Calendar.HOUR_OF_DAY));
				
				}
		
					
			String HoraNueva= fechaToma.get(Calendar.HOUR_OF_DAY) + ":" + fechaToma.get(Calendar.MINUTE);
			
		    SimpleDateFormat sdf2 = new SimpleDateFormat("dd/MM/yyyy");
		    SimpleDateFormat sdf4 = new SimpleDateFormat("yyyy/M/d");
		 	
	
			SimpleDateFormat sdf3 = new SimpleDateFormat("HH:mm");
		
					
			 to = new Toma(this.context,cantidad, sdf2.format(fechaToma.getTime()), sdf3.format(fechaToma.getTime()) , false, this.id, this.nombre, false, "2014-08-12 22:12:0"); 
			 System.out.println("Hora DESPUES de sumar la hora:  " +  sdf2.format(fechaToma.getTime()) + sdf3.format(fechaToma.getTime()));
			 
			 to.setFlarga(dia, mes, year, hora, min);
			 to.setId_medicamento(this.id);
				this.setUltimaGeneracion(sdf2.format(fechaToma.getTime()));
				this.setUltimaHora(sdf3.format(fechaToma.getTime()) );
				
		//	 to.setFoto(this.getDescripcion());
			to.save();
			//guardamos la fecha y la hora de la ultima generacin de tomas por si la pastila es cronica
		
			
	}		
	
	save();

	}

	public void partirfecha(String flar, int d, int m, int a){
		 int longitud = this.fechaInicio.length();
		 int dia, mes, year;
			if (longitud==10){
				 dia = Integer.parseInt(flar.substring(0, 2));
				 mes = Integer.parseInt(flar.substring(3, 5));
				 year= Integer.parseInt(flar.substring(6, 10));
			}else if(longitud==8){
				dia = Integer.parseInt(flar.substring(0, 0));
				 mes = Integer.parseInt(flar.substring(2, 2));
				 year= Integer.parseInt(flar.substring(4,7));
					}else{ if(flar.indexOf("-")==1){
								 dia = Integer.parseInt(flar.substring(0, 0));
								 mes = Integer.parseInt(flar.substring(2, 3));
								 year= Integer.parseInt(flar.substring(5,8));
							}else
							{
								 dia = Integer.parseInt(flar.substring(0, 1));
								 mes = Integer.parseInt(flar.substring(3, 3));
								 year= Integer.parseInt(flar.substring(5, 8));
							}
						
					}
			d=dia;
			m=mes;
			a=year;
	}
	public void partirhora(String hlar, int h, int m){
		 int longitud;
		 longitud = hlar.length();
			if (longitud==5){
				 h = Integer.parseInt(hlar.substring(0, 2));
				 m= Integer.parseInt(hlar.substring(3, 5));
				
			}
	}
	public Date getFechaLarga() {
		return fechaLarga;
	}


	public void setFechaLarga(Date fechaLarga) {
		this.fechaLarga = fechaLarga;
	}

	public String getCronico() {
		return cronico;
	}

	public void setCronico(String cronico) {
		this.cronico = cronico;
	}

	public String getUltimaGeneracion() {
		return ultimaGeneracion;
	}

	public void setUltimaGeneracion(String ultimaGeneracion) {
		this.ultimaGeneracion = ultimaGeneracion;
	}

	public String getUltimaHora() {
		return ultimaHora;
	}

	public void setUltimaHora(String ultimaHora) {
		this.ultimaHora = ultimaHora;
	}
}
