package modelo;

//Modelo


import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;

public class Perfil {

    private Context context;

    private Long id;
    private String nombre;
    private String fNacimiento;
    private String edad;
    private String usuario;
    private String passwd;
 
 

    public Perfil(Context context)
    {
        this.context = context;
    }

    public Perfil(Context context, Long id, String nombre, String fNacimiento, String usuario,  String edad, String passwd){
        this.context = context;
        this.id = id;
        this.nombre = nombre;
        this.fNacimiento=fNacimiento;
        this.edad=edad;
        this.usuario=usuario;
        this.passwd=passwd;
      
          }

    public Context getContext() {
        return context;
    }

    public void setContext(Context context) {
        this.context = context;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }
    public void setPasswd(String passwd) {
		this.passwd = passwd;
	}

	public String getfNacimiento() {
		return fNacimiento;
	}

	public void setfNacimiento(String fNacimiento) {
		this.fNacimiento = fNacimiento;
	}

	public String getUsuario() {
		return usuario;
	}

	public void setUsuario(String usuario) {
		this.usuario = usuario;
	}

	public String getEdad() {
		return edad;
	}

	public void setEdad(String edad) {
		this.edad = edad;
	}
 
	
		
    public static Perfil find(Context context, long id)
    {
    	
    	
    	PerfilDbAdapter dbAdapter = new PerfilDbAdapter(context);

        Cursor c = dbAdapter.getRegistro(id);

        Perfil perfil = Perfil.cursorToPerfil(context, c);

        c.close();

        return perfil;
    }

    public static Perfil cursorToPerfil(Context context, Cursor c)
    {
        Perfil perfil = null;
        System.out.println ("LLegamos a Perfil cursos To Perfil");

        if (c != null)
        {
            perfil = new Perfil(context);
            
        
            perfil.setId(c.getLong(c.getColumnIndex(c.getColumnName(0))));
            perfil.setNombre(c.getString(c.getColumnIndex(c.getColumnName(1))));
            perfil.setfNacimiento(c.getString(c.getColumnIndex(c.getColumnName(2))));
            perfil.setEdad(c.getString(c.getColumnIndex(c.getColumnName(3))));
            perfil.setUsuario(c.getString(c.getColumnIndex(c.getColumnName(4))));
            perfil.setPasswd(c.getString(c.getColumnIndex(c.getColumnName(5))));
           
        }

        return perfil ;
    }
    

  
    private ContentValues toContentValues()
    {
        ContentValues reg = new ContentValues();

        reg.put(PerfilDbAdapter.C_COLUMNA_ID, this.getId());
        reg.put(PerfilDbAdapter.C_COLUMNA_NOMBRE, this.getNombre());
        reg.put(PerfilDbAdapter.C_COLUMNA_FNACIMIENTO, this.getfNacimiento());
        reg.put(PerfilDbAdapter.C_COLUMNA_USUARIO, this.getUsuario());
        reg.put(PerfilDbAdapter.C_COLUMNA_EDAD, this.getEdad());
        reg.put(PerfilDbAdapter.C_COLUMNA_PASSWD, this.getPasswd());
        

        return reg;
    }

    public long save()
    {
        PerfilDbAdapter dbAdapter = new PerfilDbAdapter(this.getContext());

        // comprobamos si estamos insertando o actualizando según esté o no relleno el identificador
        if ((this.getId() == null) || (!dbAdapter.exists(this.getId())))
        {
            long nuevoId = dbAdapter.insert(this.toContentValues());

            if (nuevoId != -1)
            {
                this.setId(nuevoId);
            }
        }
        else
        {
            dbAdapter.update(this.toContentValues());
        }

        return this.getId();
    }

    public long delete()
    {
        // borramos el registro
        PerfilDbAdapter dbAdapter = new PerfilDbAdapter(this.getContext());

        return dbAdapter.delete(this.getId());
    }

	public String getPasswd() {
		return passwd;
	}

	
}
