package modelo;

import android.content.Context;
import android.graphics.Color;
import android.net.ParseException;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;


import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import com.pillcontrol.medicinas.R;





public class TomaAdapter extends ArrayAdapter<Toma>
{
	private ImageView imagen;
    private static class ViewHolder {
        TextView text1;
        TextView text2;
    }

    public TomaAdapter(Context context, ArrayList<Toma> tomas) {
    	
      //  super(context, android.R.layout.simple_dropdown_item_1line, tomas);
    	super(context, R.layout.adaptador, tomas);
       
    }
    

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {

        Toma toma = getItem(position);
        LayoutInflater inflater = LayoutInflater.from(getContext());
        convertView = inflater.inflate(R.layout.adaptador, parent, false);
        


        TextView Etiquetahora = (TextView) convertView.findViewById(R.id.label1);
        
	
		
		TextView EtiquetaNombre = (TextView) convertView.findViewById(R.id.label2);
		imagen=(ImageView)convertView.findViewById(R.id.icon);
		  imagen.setImageDrawable(getContext().getResources().getDrawable(
                  R.drawable.bolablanca));

        StringBuilder texto =new StringBuilder() .append(toma.getNombreMedicamento()).append(" Hora:").append(toma.getHora()).append(": ").append(toma.getFecha())    ;
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy/M/d HH:mm:ss:ss"); 
        Calendar c1 = GregorianCalendar.getInstance();
       
        String dia1=sdf.format(c1.getTime());  
        long horas = diferenciaFechas( dia1, toma.getFlarga());
         
         Etiquetahora.setText(toma.getNombreMedicamento() + " quedan: " + horas/60 +" h");
         EtiquetaNombre.setText("Da: "+ toma.getFecha() + " hora; " + toma.getHora());
         
        		   
        if ((horas>=-60) && (horas<0)){
        	  Etiquetahora.setTextColor(Color.GREEN);
    		   EtiquetaNombre.setTextColor(Color.GREEN);
    		   imagen.setImageResource(R.drawable.acierto);
    		   Etiquetahora.setText(toma.getNombreMedicamento() + " retraso: " + horas*-1 +" min");
        } else if ((horas>=0) && (horas<=60)){
        	 Etiquetahora.setTextColor(Color.GREEN);
  		   EtiquetaNombre.setTextColor(Color.GREEN);
  		   imagen.setImageResource(R.drawable.acierto);
     	Etiquetahora.setText(toma.getNombreMedicamento() + " Quedan: " + horas + " min");
     }   
         else if ((horas<-61) && (horas>-1440)){
        	Etiquetahora.setTextColor(Color.RED);
	           EtiquetaNombre.setTextColor(Color.RED);
	           imagen.setImageResource(R.drawable.x);
        	Etiquetahora.setText(toma.getNombreMedicamento() + " Retraso: " + horas/60*-1 + " h");
        }
        else if ((horas > 60) && (horas <120)){
        	 Etiquetahora.setTextColor(Color.BLUE);
	           EtiquetaNombre.setTextColor(Color.BLUE);
	           imagen.setImageResource(R.drawable.exclamacion);
        	//EtiquetaNombre.setText(texto +" Faltan: " + horas + "h");
        }
        else if (horas>=1440){
        	 Etiquetahora.setTextColor(Color.BLACK);
	           EtiquetaNombre.setTextColor(Color.BLACK);
	           imagen.setImageResource(R.drawable.bolablanca);
        	long dias = horas / 60 / 24;
        	
		Etiquetahora.setText(toma.getNombreMedicamento()  +" Faltan " + Long.toString(dias) + " das");
       	 	
        }
        else if ( (horas<-1440)){
        	Etiquetahora.setTextColor(Color.RED);
	           EtiquetaNombre.setTextColor(Color.RED);
	           imagen.setImageResource(R.drawable.x);
	           long dias = horas / 60 / 24 *-1;
        	Etiquetahora.setText(toma.getNombreMedicamento() + " Retraso: " + Long.toString(dias)+ " das");
        }
       
    
    
   
        return convertView;
    	
    }
public long diferenciaFechas(String inicio, String llegada){

    Date fechaInicio = null;
    Date fechaLlegada = null;

     
    SimpleDateFormat formato = new SimpleDateFormat("yyyy/M/d HH:mm:ss:ss");

     try {
        // aca realizamos el parse, para obtener objetos de tipo Date de 
        // las Strings
        fechaInicio = formato.parse(inicio);
        fechaLlegada = formato.parse(llegada);

     } catch (ParseException e) {
       // Log.e(TAG, "Funcion diferenciaFechas: Error Parse " + e);
    } catch (Exception e){
        // Log.e(TAG, "Funcion diferenciaFechas: Error " + e);
    }

     // tomamos la instancia del tipo de calendario
    Calendar calendarInicio = Calendar.getInstance();
    Calendar calendarFinal = Calendar.getInstance();

     // Configramos la fecha del calendatio, tomando los valores del date que 
    // generamos en el parse
    calendarInicio.setTime(fechaInicio);
    calendarFinal.setTime(fechaLlegada);

     // obtenemos el valor de las fechas en milisegundos
    long milisegundos1 = calendarInicio.getTimeInMillis();
    long milisegundos2 = calendarFinal.getTimeInMillis();

     // tomamos la diferencia
    long diferenciaMilisegundos = milisegundos2 - milisegundos1;

     // Despues va a depender en que formato queremos  mostrar esa 
    // diferencia, minutos, segundo horas, dias, etc, aca van algunos 
    // ejemplos de conversion

     // calcular la diferencia en segundos
    long diffSegundos =  Math.abs (diferenciaMilisegundos / 1000);

     // calcular la diferencia en minutos
    //long diffMinutos =  Math.abs (diferenciaMilisegundos / (60 * 1000));
    long diffMinutos =  (diferenciaMilisegundos / (60 * 1000));
    long restominutos = diffMinutos%60;

     // calcular la diferencia en horas
    long diffHoras =   (diferenciaMilisegundos / (60 * 60 * 1000));

     // calcular la diferencia en dias
    long diffdias = Math.abs ( diferenciaMilisegundos / (24 * 60 * 60 * 1000) );

    return diffMinutos;
 }

    @Override
    public long getItemId(int position)
    {
        return getItem(position).getId();
    }
}
