package modelo;
import android.R.integer;
import android.content.ContentValues;
import android.content.Context;
import android.content.CursorLoader;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.net.ParseException;
import android.util.Log;
import bbdd.PillControlDbHelper;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;




public class TomaDbAdapter {

	//
	// Definimos constante con el nombre de la tabla
	//
	public static final String C_TABLA = "TOMA" ;
	
    //
    // Definimos constantes con el nombre de las columnas de la tabla
    //
    public static final String C_COLUMNA_ID	= "_id";
    
    public static final String C_COLUMNA_CANTIDAD = "hip_cantidad";
    public static final String C_COLUMNA_HORA = "hip_hora";
    public static final String C_COLUMNA_FECHA = "hip_fecha";
    public static final String C_COLUMNA_FLARGA = "hip_flarga";
    public static final String C_COLUMNA_TOMADA = "hip_tomada";
    public static final String C_COLUMNA_MEDICINA = "hip_medicina";
    public static final String C_COLUMNA_NOMBRE_MEDICINA ="hip_nombreMedicina";
    //Indica si la toma esta guardada en el gestor de notificaciones
    public static final String C_COLUMNA_NOTIFICADA = "hip_notificada";
    public static final String C_COLUMNA_FOTO = "hip_foto";
    //Indica cuando se ha tomado la toma para el historial
    public static final String C_COLUMNA_FLARGATOMA = "hip_fechatomada";
    
  
    private Integer ints=0;

    private Context contexto;
    private PillControlDbHelper dbHelper;
    private SQLiteDatabase db;

    //
    // Definimos lista de columnas de la tabla para utilizarla en las consultas a la base de datos
    //
    private String[] columnas = new String[]{
            C_COLUMNA_ID,
            C_COLUMNA_CANTIDAD,
            C_COLUMNA_HORA,
            C_COLUMNA_FECHA,
            C_COLUMNA_FLARGA,
            C_COLUMNA_TOMADA,
            C_COLUMNA_MEDICINA, 
            C_COLUMNA_NOMBRE_MEDICINA,
            C_COLUMNA_NOTIFICADA,
            C_COLUMNA_FLARGATOMA,
            C_COLUMNA_FOTO,
    };
	public TomaDbAdapter(Context context)
	{

		this.contexto = context;
	}

	public TomaDbAdapter abrir() throws SQLException
	{
		 //aqiu debemos comprobar que toma exitete como lo hacemos pues ni puta idea
		
		dbHelper = new PillControlDbHelper(contexto);
		
		
		db = dbHelper.getWritableDatabase();
		
		
		return this;
	}

	public void cerrar()
	{
		dbHelper.close();
	}

	
    /**
     * Devuelve cursor con todos los registros y columnas de la tabla
     */
    public Cursor getCursor(String filtro) throws SQLException {

        if (db == null)
        abrir();
        Cursor c;
try{
        c = db.query(true, C_TABLA, columnas, filtro, null, null, null, C_COLUMNA_ID + " DESC", null);
    }finally {
   	 //casca
    }

        return c;
    }
	
	/**
	 * Devuelve cursor con todos las columnas del registro
	 */
	public Cursor getRegistro(long id) throws SQLException
	{
		
        if (db == null){
            abrir();}

        Cursor c5 = db.query(true, C_TABLA, columnas, C_COLUMNA_ID + "=" + id, null, null, null,  C_COLUMNA_FLARGA + " DESC", null);
        
       // System.out.println("AQUI QUE ENCUENTRA EL DICHOSO CUROSS.........");
       int cont = 1231;
         cont = c5.getCount();
       // System.out.println(cont);
        if (c5 != null) {
			c5.moveToFirst();
			
		}
        

     
		return c5;
        
        
        
        
	}
	public Cursor getRegistroMedicina(long id) throws SQLException
	{
		System.out.println ("llego a getRegistro");
        
    //    ArrayList<Toma> tomas = new ArrayList<Toma>();

        if (db == null){
            abrir();}

        Cursor c5 = db.query(true, C_TABLA, columnas, C_COLUMNA_MEDICINA + "=" + id, null, null, null,  C_COLUMNA_FLARGA + " DESC", null);
        
      /*  System.out.println("YA EXISTEN TOMAS DE ESTA MEDICINA..");*/
       int cont = 1231;
         cont = c5.getCount();
        //System.out.println(cont);
        if (c5 != null) {
			c5.moveToFirst();
		
		}
       return c5;
        
        
	}
	
	/**
	 * Inserta los valores en un registro de la tabla
	 */
	public long insert(ContentValues reg)
	{
		if (db == null)
			abrir();
		
		return db.insert(C_TABLA, null, reg);
	}
	
	/**
	 * Eliminar el registro con el identificador indicado
	 */
	public long delete(long id)
	{
		if (db == null)
	 abrir();
		
		return db.delete(C_TABLA, "_id=" + id, null);
	}
	public long deleteAll(long id)
	{
		if (db == null)
	 abrir();
		
		return db.delete(C_TABLA, null, null);
	}
	public long deleteMedicina(long id)
	{
		if (db == null)
	 abrir();
		
		return db.delete(C_TABLA, "hip_medicina=" + id, null);
	}
    /**
     * Modificar el registro
     */
    public long update(ContentValues reg)
    {
        long result = 0;

        if (db == null)
            abrir();

        if (reg.containsKey(C_COLUMNA_ID))
        {
            //
            // Obtenemos el id y lo borramos de los valores
            //
            long id = reg.getAsLong(C_COLUMNA_ID);

            reg.remove(C_COLUMNA_ID);

            //
            // Actualizamos el registro con el identificador que hemos extraido
            //
            result = db.update(C_TABLA, reg, "_id=" + id, null);
        }
        return result;
       
    }

    /**
     * Comprueba si existe el registro
     */
    public boolean exists(long id) throws SQLException
    {
        boolean exists ;

        if (db == null)
            abrir();

        Cursor c = db.query( true, C_TABLA, columnas, C_COLUMNA_ID + "=" + id, null, null, null, null, null);

        exists = (c.getCount() > 0);

        c.close();

        return exists;
    }

    public ArrayList<Toma> getTomas(String filtro)
    {
        ArrayList<Toma> tomas = new ArrayList<Toma>();

        if (db == null){
            abrir();}
     
        Cursor c = db.query(true, C_TABLA, columnas, filtro, null, null, null, C_COLUMNA_FLARGA, null);
 
        for(c.moveToFirst(); !c.isAfterLast(); c.moveToNext())
        {
        	
          
          
            	
     
            tomas.add(Toma.cursorToToma(contexto, c));
            
            
        }

        c.close();

        return tomas;
    }
    public ArrayList<Toma> getTomasPasadas(String filtro)
    {
        ArrayList<Toma> tomas = new ArrayList<Toma>();

        if (db == null){
            abrir();}
     //  db.delete(C_TABLA, null, null);
        Cursor c = db.query(true, C_TABLA, columnas, filtro, null, null, null, C_COLUMNA_FLARGA + " DESC", null);
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy/M/d HH:mm:ss:ss"); 
        Calendar c1 = GregorianCalendar.getInstance();
       
         String dia1=sdf.format(c1.getTime());    
    
       
         ;
      
        
           
        
        for(c.moveToFirst(); !c.isAfterLast(); c.moveToNext())
        {
        	
           
            	
            long horas = diferenciaFechas(c.getString(c.getColumnIndex(C_COLUMNA_FLARGA)), dia1);
            
    
     
            if (horas>=0)
            tomas.add(Toma.cursorToToma(contexto, c));
            
            
        }

        c.close();

        return tomas;
    }
    public ArrayList<Toma> getTomasPendientes(String filtro)
    {
        ArrayList<Toma> tomas = new ArrayList<Toma>();

        if (db == null){
            abrir();}
    
        Cursor c = db.query(true, C_TABLA, columnas, filtro, null, null, null, C_COLUMNA_FLARGA + " DESC", null);
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy/M/d HH:mm:ss:ss"); 
        Calendar c1 = GregorianCalendar.getInstance();
       
         String dia1=sdf.format(c1.getTime());  
       
    
       
         ;
      
        
           
        
        for(c.moveToFirst(); !c.isAfterLast(); c.moveToNext())
        {
        	
           
            	
            long horas = diferenciaFechas(c.getString(c.getColumnIndex(C_COLUMNA_FLARGA)), dia1);
            
            if ((horas<0)&&(horas<100))
            tomas.add(Toma.cursorToToma(contexto, c));
            
            
        }

        c.close();

        return tomas;
    }
    public long diferenciaFechas(String inicio, String llegada){

        Date fechaInicio = null;
       Date fechaLlegada = null;

        
       SimpleDateFormat formato = new SimpleDateFormat("yyyy/M/d hh:mm:ss");

        try {
           // aca realizamos el parse, para obtener objetos de tipo Date de 
           // las Strings
           fechaInicio = formato.parse(inicio);
           fechaLlegada = formato.parse(llegada);

        } catch (ParseException e) {
          // Log.e(TAG, "Funcion diferenciaFechas: Error Parse " + e);
       } catch (Exception e){
           // Log.e(TAG, "Funcion diferenciaFechas: Error " + e);
       }

        // tomamos la instancia del tipo de calendario
       Calendar calendarInicio = Calendar.getInstance();
       Calendar calendarFinal = Calendar.getInstance();

        // Configramos la fecha del calendatio, tomando los valores del date que 
       // generamos en el parse
       calendarInicio.setTime(fechaInicio);
       calendarFinal.setTime(fechaLlegada);

        // obtenemos el valor de las fechas en milisegundos
       long milisegundos1 = calendarInicio.getTimeInMillis();
       long milisegundos2 = calendarFinal.getTimeInMillis();

        // tomamos la diferencia
       long diferenciaMilisegundos = milisegundos2 - milisegundos1;

        // Despues va a depender en que formato queremos  mostrar esa 
       // diferencia, minutos, segundo horas, dias, etc, aca van algunos 
       // ejemplos de conversion

        // calcular la diferencia en segundos
       long diffSegundos =  Math.abs (diferenciaMilisegundos / 1000);

        // calcular la diferencia en minutos
       long diffMinutos =  Math.abs (diferenciaMilisegundos / (60 * 1000));
       long restominutos = diffMinutos%60;

        // calcular la diferencia en horas
       long diffHoras =   (diferenciaMilisegundos / (60 * 60 * 1000));

        // calcular la diferencia en dias
       long diffdias = Math.abs ( diferenciaMilisegundos / (24 * 60 * 60 * 1000) );

        // devolvemos el resultado en un string
       return diffHoras;
    }
    public ArrayList<Toma> getTomas2(String filtro)
    {
        ArrayList<Toma> tomas = new ArrayList<Toma>();

        if (db == null){
            abrir();}
     //  db.delete(C_TABLA, null, null);
        Cursor c = db.query(true, C_TABLA, columnas, filtro, null, null, null, null, null);
        
      
        
        for(c.moveToFirst(); !c.isAfterLast(); c.moveToNext())
        {
        	
            tomas.add(Toma.cursorToToma(contexto, c));
            
            
        }

        c.close();

        return tomas;
    }
    public ArrayList<Toma> getTomasDesc(String filtro)
    {
        ArrayList<Toma> tomas = new ArrayList<Toma>();

        if (db == null){
            abrir();}
     //  db.delete(C_TABLA, null, null);
        Cursor c = db.query(true, C_TABLA, columnas, filtro, null, null, null,C_COLUMNA_FLARGATOMA+" DESC", null);
        
      
        
        for(c.moveToFirst(); !c.isAfterLast(); c.moveToNext())
        {
        	
            tomas.add(Toma.cursorToToma(contexto, c));
            
            
        }

        c.close();

        return tomas;
    }


}
