package servicio;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Vector;

import com.pillcontrol.medicinas.R;




import modelo.Toma;
import modelo.TomaAdapter;
import modelo.TomaDbAdapter;

import controlador.MedicinaFormulario;
import controlador.TomaFormulario;



import android.app.AlarmManager;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.ContentResolver;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.provider.MediaStore.Audio;
import android.util.Log;
import android.widget.Toast;

public class Servicio extends Service implements Runnable{
	/*
	 * Implementa las funciones que estaran ejecutandose en segundo plano
	 */
	private  NotificationManager mManager;
	private LocationManager lm;
	private TomaAdapter TomasAdapter;
	private TomaDbAdapter dbAdapter;

    public static final int APP_ID_NOTIFICATION = 0;
    //final BaseDatos BBDD =  new BaseDatos(this);
    private Cursor c;
    private Cursor telefono;
    int minutos;
	int horas;
	private Context contexto=this;
	String horaalarma, filtro;
	private int NotificacionID;
	private long id;
	
	public void run(){
	
		Date time = new Date();
		 
		 minutos=time.getMinutes();
	     horas=time.getHours();
	     int horadescuento=horas-2;
	     
	     String hh;
	     if(horadescuento<10){
	    	 if(horadescuento<0){     //si coincide la hora sean las 0 o la 1 al restar -2 el valor es negativo
	    		 horadescuento=23+horadescuento;
	    		 horaalarma=""+horadescuento;
	    	 }else
	    		 horaalarma="0"+horadescuento;
	     }
	     else
	    	 horaalarma=""+horadescuento;

	     if(horas<10){
	    	 hh="0"+horas;
	     }
	     else{
	    	 hh=""+horas;
	     }
	     if(minutos<10){
	          hh=hh+":0"+minutos;
	          horaalarma=horaalarma+":0"+minutos;

	     }
	     else{
	          hh=hh+":"+minutos;
	          horaalarma=horaalarma+":"+minutos;
	     }
         SimpleDateFormat sf = new SimpleDateFormat("dd/MM/yyyy");
         Log.d("Servicio dia", sf.toString());
       
         Calendar calendari = Calendar.getInstance();
         Log.d("Servicio fecha", sf.format(calendari.getTime()));
         String args[]={sf.format(calendari.getTime()),hh};
         Log.d("Servicio hora", hh);
         Log.d("Servicio hora alarma", horaalarma);
         dbAdapter = new TomaDbAdapter(this);
         dbAdapter.abrir();
       
         //s
    
         
       // ("INSERT INTO TOMA(_id, hip_cantidad, hip_fecha, hip_flarga, hip_tomada, hip_medicina, hip_notificada, hip_fechatomada) VALUES (1,'700','12-08-2014','2014-08-12 22:12:00','false',1,'0','2014-08-12 22:12:00')");
         filtro = new String("hip_tomada = 0 and hip_fecha = " + "'" + sf.format(calendari.getTime()) + "'"); 
         		
         		
         		//"" +sf.format(calendari.getTime()) );
         Log.d("Filtro",  filtro);
         TomasAdapter = new TomaAdapter(this, dbAdapter.getTomas(filtro));
         Log.d("Numero de tomas encontradas",  Integer.toString(TomasAdapter.getCount()));
         
         // filtro = filtro + sf.toString();
          Log.d("Filtro", filtro);
    
         
         Toma t;
         for (int i=0; i<TomasAdapter.getCount(); i++){
         	t = TomasAdapter.getItem(i);
         	if (t.getCantidad()==453)
         		NotificarCantidad();
         	if ((t.getHoraInt()==horas) && (t.getMin()==minutos)){
         		id=t.getId();
            		Notificar();
         		
         	}
         }
         	
         
         
      
		 }
		
	
	private Handler handler = new Handler() {
	    public void handleMessage() {
	            
	                 Notificar();
	               
	            }
	    
	};
	@Override
	public void onCreate() {	
		super.onCreate();
		mManager=(NotificationManager)getSystemService(NOTIFICATION_SERVICE);
		lm=(LocationManager)getSystemService(Context.LOCATION_SERVICE);

	}
	@Override
	public IBinder onBind(Intent intent) {
		   return null;
	}

    @Override
    public void onDestroy() {
          super.onDestroy();
    }

   

    private void Notificar() {
	 
    	//Prepara la actividad que se abrira cuando el usuario pulse la notificacin
        	Intent intentNot = new Intent(this, TomaFormulario.class);
        	
           	intentNot.putExtra("notificacionID", id);
        	
        	intentNot.putExtra(TomaDbAdapter.C_COLUMNA_ID, id);
        	
        	
        	intentNot.putExtra("modo",551);
        	intentNot.putExtra("editable", false);
        	Notification notification = new Notification(R.drawable.itoma,"Es hora de tomar tu medicina", System.currentTimeMillis());
        	notification.setLatestEventInfo(this, "Pill Control","Es Hora de tomar tu medicicina.",
                PendingIntent.getActivity(this.getBaseContext(), 0, intentNot, PendingIntent.FLAG_CANCEL_CURRENT));
        	
        	
        	
        	
        	notification.sound = Uri.parse(ContentResolver.SCHEME_ANDROID_RESOURCE
        	        + "://" + getPackageName() + "/raw/cancion");
        	
        	Log.d("musica", "android.resource://" + getPackageName() + "//cancion.mp3");
        	//notification.defaults|= Notification.DEFAULT_SOUND;
        //Le aade vibracin
        	 notification.defaults|= Notification.DEFAULT_VIBRATE;
        //Le aade luz mediante LED
            notification.defaults |= Notification.DEFAULT_LIGHTS;
        //La notificacin se detendr cuando el usuario pulse en ella
            notification.flags = Notification.FLAG_AUTO_CANCEL;
         //insistir hasta que el usuario cancele
       //     notification.flags=Notification.FLAG_INSISTENT;
     
        //Intenta establecer el color y el parpadeo de la bombilla lED
            try
            {
                notification.ledARGB = 0xff00ff00;
                notification.ledOnMS = 300;
                notification.ledOffMS = 1000;
                notification.flags |= Notification.FLAG_SHOW_LIGHTS;
            }catch(Exception ex)
            {
               
            }
        //Lanza la notificacin
        	mManager.notify(APP_ID_NOTIFICATION, notification);
       
 
     	}
    
    private void NotificarCantidad() {
   	 
    	//Prepara la actividad que se abrira cuando el usuario pulse la notificacin
        	Intent intentNot = new Intent(this, MedicinaFormulario.class);
        	
           	intentNot.putExtra("notificacionID", id);
        	
        	intentNot.putExtra(TomaDbAdapter.C_COLUMNA_ID, id);
        	
        	
        	intentNot.putExtra("tipo",0);
        	Notification notification = new Notification(R.drawable.ialmacen,"Debes comprar mas pastillas", System.currentTimeMillis());
        	notification.setLatestEventInfo(this, "Escased de pastillas","Pastillas escasas",
                PendingIntent.getActivity(this.getBaseContext(), 0, intentNot, PendingIntent.FLAG_CANCEL_CURRENT));
        //Le aade sonido
        	notification.sound=Uri.parse("file:///sdcard/media/alarma.mp3");
        //sonido por defecto
        	//notification.defaults|= Notification.DEFAULT_SOUND;
        //Le aade vibracin
        	 notification.defaults|= Notification.DEFAULT_VIBRATE;
        //Le aade luz mediante LED
            notification.defaults |= Notification.DEFAULT_LIGHTS;
        //La notificacin se detendr cuando el usuario pulse en ella
           // notification.flags = Notification.FLAG_AUTO_CANCEL;
         //insistir hasta que el usuario cancele
            notification.flags=Notification.FLAG_INSISTENT;
     
        //Intenta establecer el color y el parpadeo de la bombilla lED
            try
            {
                notification.ledARGB = 0xff00ff00;
                notification.ledOnMS = 300;
                notification.ledOffMS = 1000;
                notification.flags |= Notification.FLAG_SHOW_LIGHTS;
            }catch(Exception ex)
            {
               
            }
        //Lanza la notificacin
        	mManager.notify(APP_ID_NOTIFICATION, notification);
 
     	}
    @Override
    public void onStart(Intent intent, int startId) {
    	super.onStart(intent, startId);
    	Thread thread = new Thread(this);
    	thread.start();
    }


}
